<?php
header("Content-Type: text/html;charset=utf-8");

class cls_Control_Movimiento {

	private $db_nombretabla = "control_movimiento";
	private $db_nombrevista = "vista_control_movimiento";
	private $db_filas = "*";
	private $control_movimiento_id = 0;
	private $tienda_id = 0;
	private $tienda_nombre = "";
	private $origen_id = 0;
	private $origen_nombre = "";
	private $destino_id = 0;
	private $almacen_general_id = 0;
	private $almacen_tienda_id = 0;
	private $movimiento_id = 0;
	private $movimiento_producto_id = 0;
	private $producto_id = 0;
	private $producto_nombre = "";
	private $producto_nombre_alternativo = "";
	private $producto_codigo = "";
	private $producto_imagen = "";
	private $producto_codigo_barras = "";
	private $producto_fabricante = "";
	private $producto_modelo = "";
	private $producto_serie = "";
	private $producto_stock_minimo = 0;
	private $producto_estado = "";
	private $unidades = 0;
	private $tipo_movimiento = "";
	private $estado = "";
	private $movimiento_fecha = "";
	private $usuario_modificacion = 0;
	private $fecha_creacion = "";
	private $fecha_modificacion = "";
	private $activo = true;
	
	public function __construct(){
		$this->db_filas = "control_movimiento_id, tienda_id, tienda_nombre, origen_id, origen_nombre, destino_id, almacen_general_id, almacen_tienda_id, movimiento_id, movimiento_producto_id, producto_id, producto_nombre, nombre_alternativo, producto_codigo, producto_imagen, producto_codigo_barras, producto_fabricante, producto_modelo, producto_serie, producto_stock_minimo, producto_estado, unidades, tipo_movimiento, estado, movimiento_fecha, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
	}

	static public function Indice($codigo){
		$current = new cls_Control_Movimiento();
		$conn = new cls_Conexion();
		$filtro = "control_movimiento_id = ?";
		$values = array();
		array_push($values, $codigo );
		$lista = $conn->buscar_datos($current->db_nombrevista, $current->db_filas, $filtro, $values, "");
		$current->db_mensaje = $conn->getMensaje();
		for ($indice=0; $indice<count($lista); $indice++){
			$current->control_movimiento_id = $lista[$indice]["control_movimiento_id"];
			$current->origen_id = $lista[$indice]["origen_id"];
			$current->origen_nombre = $lista[$indice]["origen_nombre"];
			$current->tienda_id = $lista[$indice]["tienda_id"];
			$current->tienda_nombre = $lista[$indice]["tienda_nombre"];
			$current->destino_id = $lista[$indice]["destino_id"];
			$current->almacen_general_id = $lista[$indice]["almacen_general_id"];
			$current->almacen_tienda_id = $lista[$indice]["almacen_tienda_id"];
			$current->movimiento_id = $lista[$indice]["movimiento_id"];
			$current->movimiento_producto_id = $lista[$indice]["movimiento_producto_id"];
			$current->producto_id = $lista[$indice]["producto_id"];
			$current->producto_nombre = $lista[$indice]["producto_nombre"];
			$current->producto_nombre_alternativo = $lista[$indice]["nombre_alternativo"];
			$current->producto_codigo = $lista[$indice]["producto_codigo"];
			$current->producto_imagen = $lista[$indice]["producto_imagen"];
			$current->producto_codigo_barras = $lista[$indice]["producto_codigo_barras"];
			$current->producto_fabricante = $lista[$indice]["producto_fabricante"];
			$current->producto_modelo = $lista[$indice]["producto_modelo"];
			$current->producto_serie = $lista[$indice]["producto_serie"];
			$current->producto_stock_minimo = $lista[$indice]["producto_stock_minimo"];
			$current->producto_estado = $lista[$indice]["producto_estado"];
			$current->unidades = $lista[$indice]["unidades"];
			$current->tipo_movimiento = $lista[$indice]["tipo_movimiento"];
			$current->estado = $lista[$indice]["estado"];
			$current->movimiento_fecha = $lista[$indice]["movimiento_fecha"];
			$current->usuario_modificacion = $lista[$indice]["usuario_modificacion"];
			$current->fecha_creacion = $lista[$indice]["fecha_creacion"];
			$current->fecha_modificacion = $lista[$indice]["fecha_modificacion"];
			$current->activo = $lista[$indice]["activo"];
		}
		return $current;
	}

	public function get_control_movimiento_id() { return $this->control_movimiento_id; }
	public function get_origen_id() { return $this->origen_id; }
	public function get_origen_nombre() { return $this->origen_nombre; }
	public function get_tienda_id() { return $this->tienda_id; }
	public function get_tienda_nombre() { return $this->tienda_nombre; }
	public function get_destino_id() { return $this->destino_id; }
	public function get_almacen_general_id() { return $this->almacen_general_id; }
	public function get_almacen_tienda_id() { return $this->almacen_tienda_id; }
	public function get_movimiento_id() { return $this->movimiento_id; }
	public function get_movimiento_producto_id() { return $this->movimiento_producto_id; }
	public function get_producto_id() { return $this->producto_id; }
	public function get_producto_nombre() { return $this->producto_nombre; }
	public function get_producto_nombre_alternativo() { return $this->producto_nombre_alternativo; }
	public function get_producto_codigo() { return $this->producto_codigo; }
	public function get_producto_imagen() { return $this->producto_imagen; }
	public function get_producto_codigo_barras() { return $this->producto_codigo_barras; }
	public function get_producto_fabricante() { return $this->producto_fabricante; }
	public function get_producto_modelo() { return $this->producto_modelo; }
	public function get_producto_serie() { return $this->producto_serie; }
	public function get_producto_stock_minimo() { return $this->producto_stock_minimo; }
	public function get_producto_estado() { return $this->producto_estado; }
	public function get_unidades() { return $this->unidades; }
	public function get_tipo_movimiento() { return $this->tipo_movimiento; }
	public function get_estado() { return $this->estado; }
	public function get_movimiento_fecha() { return $this->movimiento_fecha; }
	public function get_usuario_modificacion(){  return $this->usuario_modificacion; }
	public function get_fecha_creacion(){  return $this->fecha_creacion; }
	public function get_fecha_modificacion(){  return $this->fecha_modificacion; }
	public function get_activo() { return $this->activo; }
	
	public function set_control_movimiento_id($control_movimiento_id){ $this->control_movimiento_id = $control_movimiento_id; }
	public function set_origen_id($origen_id){ $this->origen_id = $origen_id; }
	public function set_tienda_id($tienda_id){ $this->tienda_id = $tienda_id; }
	public function set_destino_id($destino_id){ $this->destino_id = $destino_id; }
	public function set_almacen_general_id($almacen_general_id){ $this->almacen_general_id = $almacen_general_id; }
	public function set_almacen_tienda_id($almacen_tienda_id){ $this->almacen_tienda_id = $almacen_tienda_id; }
	public function set_movimiento_id($movimiento_id){ $this->movimiento_id = $movimiento_id; }
	public function set_movimiento_producto_id($movimiento_producto_id){ $this->movimiento_producto_id = $movimiento_producto_id; }
	public function set_producto_id($producto_id){ $this->producto_id = $producto_id; }
	public function set_unidades($unidades){ $this->unidades = $unidades; }
	public function set_tipo_movimiento($tipo_movimiento){ $this->tipo_movimiento = $tipo_movimiento; }
	public function set_estado($estado){ $this->estado = $estado; }
	public function set_movimiento_fecha($movimiento_fecha){ $this->movimiento_fecha = $movimiento_fecha; }
	public function set_usuario_modificacion($usuario_modificacion){ $this->usuario_modificacion = $usuario_modificacion; }
	public function set_fecha_creacion($fecha_creacion){ $this->fecha_creacion = $fecha_creacion; }
	public function set_fecha_modificacion($fecha_modificacion){ $this->fecha_modificacion = $fecha_modificacion; }
	public function set_activo($activo){ $this->activo = $activo; }
	
	public function registrar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ( $this->control_movimiento_id == 0 ){ // REGISTER
			array_push($values, $this->tienda_id);
			array_push($values, $this->origen_id);
			array_push($values, $this->destino_id);
			array_push($values, $this->almacen_general_id);
			array_push($values, $this->almacen_tienda_id);
			array_push($values, $this->movimiento_id);
			array_push($values, $this->movimiento_producto_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->unidades);
			array_push($values, $this->tipo_movimiento);
			array_push($values, $this->estado);
			array_push($values, $this->movimiento_fecha);
			array_push($values, $usuario_editor);
			$respuesta = $conn->nuevo_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
			if ( $respuesta ){
				$this->control_movimiento_id = $conn->getlastId();
			}
		} else { // UPDATE
			array_push($values, $this->tienda_id);
			array_push($values, $this->origen_id);
			array_push($values, $this->destino_id);
			array_push($values, $this->almacen_general_id);
			array_push($values, $this->almacen_tienda_id);
			array_push($values, $this->movimiento_id);
			array_push($values, $this->movimiento_producto_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->unidades);
			array_push($values, $this->tipo_movimiento);
			array_push($values, $this->estado);
			array_push($values, $this->movimiento_fecha);
			array_push($values, $usuario_editor);
			array_push($values, $this->control_movimiento_id);
			$respuesta = $conn->editar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		}
		return $respuesta;
	}
	
	public function importar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
			array_push($values, $this->control_movimiento_id);
			array_push($values, $this->tienda_id);
			array_push($values, $this->origen_id);
			array_push($values, $this->destino_id);
			array_push($values, $this->almacen_general_id);
			array_push($values, $this->almacen_tienda_id);
			array_push($values, $this->movimiento_id);
			array_push($values, $this->movimiento_producto_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->unidades);
			array_push($values, $this->tipo_movimiento);
			array_push($values, $this->estado);
			array_push($values, $this->movimiento_fecha);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
			
			array_push($values, $this->tienda_id);
			array_push($values, $this->origen_id);
			array_push($values, $this->destino_id);
			array_push($values, $this->almacen_general_id);
			array_push($values, $this->almacen_tienda_id);
			array_push($values, $this->movimiento_id);
			array_push($values, $this->movimiento_producto_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->unidades);
			array_push($values, $this->tipo_movimiento);
			array_push($values, $this->estado);
			array_push($values, $this->movimiento_fecha);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
		$respuesta = $conn->importar_registro($this->db_nombretabla, $values);
		$this->db_mensaje = $conn->GetMensaje();
		if ( $respuesta ){
			$this->control_movimiento_id = $conn->getlastId();
		};
		return $respuesta;
	}

	public function eliminar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ($this->control_movimiento_id > 0){ // DELETE
			array_push($values, $usuario_editor);
			array_push($values, $this->control_movimiento_id );
			$respuesta = $conn->eliminar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		} else {
			$this->db_mensaje = "No se puede realizar este proceso";
		}
		return $respuesta;
	}
}

class cls_Group_Control_Movimiento {

	protected $db_mensaje = "";
	protected $db_nombre_tabla = "vista_control_movimiento";
	protected $db_nombres_columnas = "*";
	protected $db_filtro = "1";
	protected $db_agrupar = "";
	protected $db_orden_columna = "movimiento_fecha";
	protected $db_orden_direccion = "ASC";
	protected $db_cantidad = 0;
	protected $db_filtro_datos = array();
	protected $db_filas = array();
	
	public function __construct(){
		$this->db_nombres_columnas = "control_movimiento_id, tienda_id, tienda_nombre, origen_id, origen_nombre, destino_id, destino_nombre, almacen_general_id, almacen_tienda_id, movimiento_id, movimiento_producto_id, producto_id, producto_nombre, nombre_alternativo, producto_codigo, producto_imagen, producto_codigo_barras, producto_fabricante, producto_modelo, producto_serie, producto_stock_minimo, producto_estado, unidades, tipo_movimiento, estado, movimiento_fecha, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
		$this->db_orden_columna = "movimiento_fecha";
	}

	static public function Export($fecha_min, $fecha_max, $ordendireccion="ASC", $ordencolumna="control_movimiento_id", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Control_Movimiento();
		$current->db_filtro = "DATE(fecha_creacion) > DATE(?) AND DATE(fecha_creacion) <= DATE(?)";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $fecha_min);
		array_push($current->db_filtro_datos, $fecha_max);
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function Buscar($buscar="", $ordendireccion="DESC", $ordencolumna="movimiento_fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Control_Movimiento();
		$l_buscar = explode(" ", $buscar);
		$current->db_filtro = "";
		for ($idx=0; $idx<count($l_buscar); $idx++){
			array_push($current->db_filtro_datos, "%".$l_buscar[$idx]."%" );
			$current->db_filtro .= "CONCAT(producto_codigo, ' ', producto_nombre, ' ', nombre_alternativo) LIKE ? AND ";
		}
		$current->db_filtro .= "activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function IngresoTiendaFecha($tienda, $buscar, $fecha_min, $fecha_max, $ordendireccion="DESC", $ordencolumna="movimiento_fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Control_Movimiento();
		$l_buscar = explode(" ", $buscar);
		$current->db_filtro = "";
		for ($idx=0; $idx<count($l_buscar); $idx++){
			array_push($current->db_filtro_datos, "%".$l_buscar[$idx]."%" );
			$current->db_filtro .= "CONCAT(producto_codigo, ' ', producto_nombre, ' ', nombre_alternativo) LIKE ? AND ";
		}
		array_push($current->db_filtro_datos, $tienda );
		array_push($current->db_filtro_datos, $fecha_min );
		array_push($current->db_filtro_datos, $fecha_max );
		$current->db_filtro .= "tienda_id = ? AND DATE(movimiento_fecha) >= DATE(?) AND DATE(movimiento_fecha) <= DATE(?) AND estado LIKE 'Ingreso' AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function SalidaTiendaFecha($tienda, $buscar, $fecha_min, $fecha_max, $ordendireccion="DESC", $ordencolumna="movimiento_fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Control_Movimiento();
		$l_buscar = explode(" ", $buscar);
		$current->db_filtro = "";
		for ($idx=0; $idx<count($l_buscar); $idx++){
			array_push($current->db_filtro_datos, "%".$l_buscar[$idx]."%" );
			$current->db_filtro .= "CONCAT(producto_codigo, ' ', producto_nombre, ' ', nombre_alternativo) LIKE ? AND ";
		}
		array_push($current->db_filtro_datos, $tienda );
		array_push($current->db_filtro_datos, $fecha_min );
		array_push($current->db_filtro_datos, $fecha_max );
		$current->db_filtro .= "tienda_id = ? AND DATE(movimiento_fecha) >= DATE(?) AND DATE(movimiento_fecha) <= DATE(?) AND estado LIKE 'Salida' AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	public function cargar_datos( $offset, $cantidad ){
		$conn = new cls_Conexion();
		$this->db_filas = $conn->listar_filas( $this->db_nombre_tabla, $this->db_nombres_columnas, $this->db_orden_columna, $this->db_orden_direccion, $this->db_filtro, $this->db_filtro_datos, $offset, $cantidad, $this->db_agrupar );
		$this->db_mensaje = $conn->GetMensaje();
	}
	public function get_cantidad_cargados(){
		return count($this->db_filas);
	}
	public function get_cantidad(){
		return $this->db_cantidad;
	}
	
	public function get_control_movimiento_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["control_movimiento_id"];
			return $val;
		}
		return 0;
	}
	public function get_origen_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["origen_id"];
			return $val;
		}
		return 0;
	}
	public function get_origen_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["origen_nombre"];
			return $val;
		}
		return "";
	}
	public function get_tienda_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["tienda_id"];
			return $val;
		}
		return 0;
	}
	public function get_tienda_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["tienda_nombre"];
			return $val;
		}
		return "";
	}
	public function get_destino_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["destino_id"];
			return $val;
		}
		return 0;
	}
	public function get_almacen_general_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["almacen_general_id"];
			return $val;
		}
		return 0;
	}
	public function get_almacen_tienda_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["almacen_tienda_id"];
			return $val;
		}
		return 0;
	}
	public function get_movimiento_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_id"];
			return $val;
		}
		return 0;
	}
	public function get_movimiento_producto_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_producto_id"];
			return $val;
		}
		return 0;
	}
	public function get_producto_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_id"];
			return $val;
		}
		return 0;
	}
	public function get_producto_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_nombre"];
			return $val;
		}
		return "";
	}
	public function get_producto_nombre_alternativo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["nombre_alternativo"];
			return $val;
		}
		return "";
	}
	public function get_producto_codigo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_codigo"];
			return $val;
		}
		return "";
	}
	public function get_producto_imagen($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_imagen"];
			return $val;
		}
		return "";
	}
	public function get_producto_codigo_barras($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_codigo_barras"];
			return $val;
		}
		return "";
	}
	public function get_producto_fabricante($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_fabricante"];
			return $val;
		}
		return "";
	}
	public function get_producto_modelo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_modelo"];
			return $val;
		}
		return "";
	}
	public function get_producto_serie($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_serie"];
			return $val;
		}
		return "";
	}
	public function get_producto_stock_minimo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_stock_minimo"];
			return $val;
		}
		return 0;
	}
	public function get_producto_estado($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_estado"];
			return $val;
		}
		return "";
	}
	public function get_unidades($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["unidades"];
			return $val;
		}
		return 0;
	}
	public function get_tipo_movimiento($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["tipo_movimiento"];
			return $val;
		}
		return "";
	}
	public function get_estado($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["estado"];
			return $val;
		}
		return "";
	}
	public function get_movimiento_fecha($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["movimiento_fecha"];
			return $val;
		}
		return "";
	}
	public function get_usuario_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["usuario_modificacion"];
			return $val;
		}
		return 0;
	}
	public function get_fecha_creacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_creacion"];
			return $val;
		}
		return "";
	}
	public function get_fecha_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_modificacion"];
			return $val;
		}
		return "";
	}
	public function get_activo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["activo"];
			return $val;
		}
		return "";
	}
};
?>		
